$ = (el) => document.querySelectorAll(el);
let ws = null,
    lprv = 0,
    Ect = ['click', 'touch'],
    Echk = ['change', 'keyup'],
    img = $('.image')[0],
    prv = $('.preview div'),
    amn = $('.nav input')[0];
addMessage = (ne, m) => $('.info > i')[ne == 1 ? 1:0].children[0].innerText = m;
addInfo = () => img.children[0] ? addMessage(0, "Format PNG: " + (img.children[0].src.length/1024).toFixed(2) + " KB"):'';
addImage = (a) => {
    img.children[0] ? img.children[0].remove():'';
    img.appendChild(a.cloneNode(true));
    addInfo();
    $('.nav input')[0].value = img.children[0].getAttribute('nameTime') + '.png';
    $('.nav a')[0].setAttribute('href', img.children[0].src);
    $('.nav a')[0].setAttribute('download', $('.nav input')[0].value);
}
Ect.forEach(e => prv
    .forEach(s => {
        s.addEventListener(e, a => {
            if (a.target.src) {
                addImage(a.target);
                addInfo();                
            }
        })
    })
)
Echk.forEach(e => amn
    .addEventListener(e, a => {
        $('.nav a')[0].setAttribute('download', amn.value);
    })
)
startSocket = () => {
    ws = new WebSocket('ws://'+document.location.host+'/ws');
    //ws = new WebSocket('ws://192.168.4.1/ws');
    ws.onopen    = (e) => addMessage(1, "Connected");
    ws.onclose   = (e) => addMessage(1, "Disconnected");
    ws.onerror   = (e) => addMessage(1, "Error: ", e);
    ws.onmessage = (e) => {
        let obj = JSON.parse(e.data, function (k, v) {
            let somes = (v) => {
                let result = false;
                [].slice.call(prv).some(s => { 
                    if (!s.children[0]) {
                        let image = new Image();
                        image.src = 'data:image/png;base64,' + v;
                        image.setAttribute('nameTime', new Date().toLocaleTimeString([], {hour: '2-digit', minute:'2-digit'}));
                        s.appendChild(image);
                        addImage(image);
                        result = s;
                        return s;
                    }
                })
                return result;
            }
            if (k == "action") {
                v == "printStart" ? $('body')[0].classList.add('load'):'';
                v == "completeSend" ? $('body')[0].classList.remove('load'):'';
                addMessage(1, v);
                addInfo();              
            } 
            if (k == "image") {
                if (!somes(v)) {                  
                    prv[lprv].children[0].src = 'data:image/png;base64,' + v;
                    addImage(prv[lprv].children[0]);
                    lprv == 2 ? lprv = 0:lprv += 1;                   
                }
                
               
            }
        })      
    }
}
window.addEventListener('load', function () {     
    startSocket();
    addMessage(0, "Press \"Print\" button");   
})